 [Suggested description]
 An out-of-bounds read in the SNMP stack in Contiki-NG 4.4 and earlier
 allows an attacker to cause a denial of service and potentially
 disclose information via crafted SNMP packets to snmp_ber_decode_string_len_buffer in os/net/app-layer/snmp/snmp-ber.c.

 ------------------------------------------

 [Additional Information]
 # Bug Description
 Missing size check during SNMP message decoding.

 In
 contiki-ng/os/net/app-layer/snmp/snmp-message.c#snmp_message_decode,
 the community field is read as a variable-sized string. The string
 field decoding is done in
 contiki-ng/os/net/app-layer/snmp/snmp-ber.c#snmp_ber_decode_string_len_buffer
 by parsing potentially untrusted input bytes. No checks are performed
 in the parsing function or on the length of the field/the pointer
 after parsing. As a result, an out of bounds read is performed.

 # Source Code References
 - snmp_message_decode: https://github.com/contiki-ng/contiki-ng/blob/release/v4.4/os/net/app-layer/snmp/snmp-message.c#L143 
 - snmp_ber_decode_string_len_buffer: https://github.com/contiki-ng/contiki-ng/blob/release/v4.4/os/net/app-layer/snmp/snmp-ber.c#L219

 # Impact
 Denial of Service and/or information disclosure via crafted SNMP packet

 ------------------------------------------

 [VulnerabilityType Other]
 Out of Bounds Read

 ------------------------------------------

 [Vendor of Product]
 Contiki-NG

 ------------------------------------------

 [Affected Product Code Base]
 Contiki-NG OS - 4.4 and earlier

 ------------------------------------------

 [Affected Component]
 SNMP Application Layer Network Stack

 ------------------------------------------

 [Attack Type]
 Remote

 ------------------------------------------

 [Impact Denial of Service]
 true

 ------------------------------------------

 [Impact Information Disclosure]
 true

 ------------------------------------------

 [Attack Vectors]
 Sending crafted SNMP packets

 ------------------------------------------

 [Reference]
 Anonymized

 ------------------------------------------

 [Has vendor confirmed or acknowledged the vulnerability?]
 true

 ------------------------------------------

 [Discoverer]
 Anonymized
 
Use CVE-2020-BLINDED.