# Analyzing the Crash
The crash occurs in hci_cmd_done at pc=0x080025b8, after on an error case in `bt_send`, NULL is passed to `hci_cmd_done` within `hci_tx_thread`.

## Interactive Bug Triaging with known Bug
To interactively see this, set a breakpoint on function `hci_cmd_done` (address 0x80025B4) and observe the value of `buf`, which is passed to the function as the second argument (one argument is eliminated during inlining by the compiler), which means in register `r1`.

```
./run.sh -b 0x80025B4
```

Here we are looking NULL value of `buf`.



When hitting the function for the first time, we see:
```
ipdb> uc.regs.r1
0x0
```

As indicated in the more detailed bug report, this stems from a wrongly handled error case in bluetooth HCI.
