# Crash Analysis
The crash occurs due to an omitted size check while receiving rf frames.

This is a false positive, rather than a security issue. The reason for this is that firmware logic relies on the fact that the size of a radio frame which is received from hardware will never exceed a maximum of 127. Firmware will read a value from hardware input which it trusts to be in bounds. Thus, firmware omits checking the size itself.

For fuzzing, we applied a [ieee802154_rf2xx_size_check.patch](../../../building/patches/ieee802154_rf2xx_size_check.patch) which introduces such a check and restricts the size of the received frame to the expected limit if necessary.
