# P2IM PLC
In the method `process_FC3` from `Modbus`, the bounds check is performed with user controlled data.
This allows an attacker to overwrite data following the `au8Buffer`.
```C
int8_t Modbus::process_FC3( uint16_t *regs, uint8_t u8size )
{

    uint8_t u8StartAdd = word( au8Buffer[ ADD_HI ], au8Buffer[ ADD_LO ] );
    uint8_t u8regsno = word( au8Buffer[ NB_HI ], au8Buffer[ NB_LO ] );
    uint8_t u8CopyBufferSize;
    uint8_t i;

    au8Buffer[ 2 ]       = u8regsno * 2;
    u8BufferSize         = 3;

    for (i = u8StartAdd; i < u8StartAdd + u8regsno; i++)
    {
        au8Buffer[ u8BufferSize ] = highByte(regs[i]);
        u8BufferSize++;
        au8Buffer[ u8BufferSize ] = lowByte(regs[i]);
        u8BufferSize++;
    }
    u8CopyBufferSize = u8BufferSize +2;
    sendTxBuffer();

    return u8CopyBufferSize;
}
```

In the provided input the `rx_callback` array from the UART subsystem is overwritten, resulting in a crash while branching to the corrupted address.
For an attacker it would be possible to set the pointer to any value and thus allows arbitrary control over the instruction pointer.
